#ifndef __LCM_H__
#define __LCM_H__

#include<avr/io.h>
#include<util/delay.h>
//#include"pic_temp.h"

#define NOP() asm("nop")


#define	BLACK	0x0000
#define	BLUE	0x001F
#define	RED 	0xF800
#define	GREEN 	0x07E0
#define CYAN	0x07FF
#define MAGENTA 0xF81F
#define YELLOW	0xFFE0
#define WHITE	0xFFFF



#define DATA_LO_DDR  DDRA
#define DATA_LO_PORT PORTA
#define DATA_LO_PIN  PINA

#define DATA_HI_DDR  DDRD
#define DATA_HI_PORT PORTD
#define DATA_HI_PIN  PIND

#define LCD_CS_DDR  DDRB
#define LCD_CS_PORT PORTB
#define LCD_CS_PIN  PINB
#define LCD_CS_BIT  0


#define LCD_RS_DDR  DDRB
#define LCD_RS_PORT PORTB
#define LCD_RS_PIN  PINB
#define LCD_RS_BIT  1


#define LCD_WR_DDR  DDRB
#define LCD_WR_PORT PORTB
#define LCD_WR_PIN  PINB
#define LCD_WR_BIT  2


#define LCD_RD_DDR  DDRB
#define LCD_RD_PORT PORTB
#define LCD_RD_PIN  PINB
#define LCD_RD_BIT  3

#define LCD_RST_DDR  DDRC
#define LCD_RST_PORT PORTC
#define LCD_RST_PIN  PINC
#define LCD_RST_BIT  0

#define DATA_INPUT() {\
						DATA_LO_DDR = 0x00;\
						DATA_HI_DDR = 0x00;\
						}
#define DATA_OUTPUT() {\
						DATA_LO_DDR = 0xff;\
						DATA_HI_DDR = 0xff;\
						}
#define LCD_CS_H() LCD_CS_PORT |= 1<<LCD_CS_BIT
#define LCD_CS_L() LCD_CS_PORT &= ~(1<<LCD_CS_BIT)

#define LCD_RS_H() LCD_RS_PORT |= 1<<LCD_RS_BIT
#define LCD_RS_L() LCD_RS_PORT &= ~(1<<LCD_RS_BIT)

#define LCD_WR_H() LCD_WR_PORT |= 1<<LCD_WR_BIT
#define LCD_WR_L() LCD_WR_PORT &= ~(1<<LCD_WR_BIT)

#define LCD_RD_H() LCD_RD_PORT |= 1<<LCD_RD_BIT
#define LCD_RD_L() LCD_RD_PORT &= ~(1<<LCD_RD_BIT)

#define LCD_RST_H() LCD_RST_PORT |= 1<<LCD_RST_BIT
#define LCD_RST_L() LCD_RD_PORT &= ~(1<<LCD_RST_BIT)


#define PORT_INI() {\
						DATA_INPUT();\
						LCD_CS_H();\
						LCD_RS_H();\
						LCD_WR_H();\
						LCD_RD_H();\
						LCD_RST_L();\
						LCD_CS_DDR |= 1<<LCD_CS_BIT;\
						LCD_RS_DDR |= 1<<LCD_RS_BIT;\
						LCD_WR_DDR |= 1<<LCD_WR_BIT;\
						LCD_RD_DDR |= 1<<LCD_RD_BIT;\
						LCD_RST_DDR |= 1<<LCD_RST_BIT;\
						}


extern void LCD_Init(void);
extern void LCD_WriteStart();
extern void LCD_WriteData(unsigned int val);
extern void LCD_WriteEnd();
extern void LCD_ReadStart();
extern unsigned int LCD_ReadData();
extern void LCD_ReadEnd();
extern void LCD_SetXY(unsigned int x, unsigned int y);
extern void LCD_SetWindow(unsigned int startX,unsigned int startY,unsigned int endX,unsigned int endY);
extern void LCD_SetWindowToFullScreen();
extern void LCD_test(void);
extern void LCD_ClearScreen(unsigned int color);
extern unsigned char LCD_DrawPicture(unsigned char startX, unsigned char startY, unsigned int *pic, unsigned char sizeX, unsigned char sizeY);
extern unsigned char LCD_DrawPicture2(unsigned char startX, unsigned char startY, unsigned int *pic, unsigned char sizeX, unsigned char sizeY);

#endif
